class WhiteKnight {
	HIDCERBERUS_URLS := ["http://localhost:26762/api/v1/hidguardian/whitelist/remove/"
		, "http://localhost:26762/api/v1/hidguardian/whitelist/add/"]
	WhitelistedPIDs := {}
	
	__New(this_script := 1){
		if (this_script){
			this.HidGuardianWhitelist(1)
		}
	}
	
	__Delete(){
		for pid, unused in this.WhitelistedPIDs {
			this.HidGuardianWhitelist(0, pid)
		}
	}
	
	HidGuardianWhitelist(state, pid := 0){
		if (pid == 0)
			pid := DllCall("GetCurrentProcessId")
		pid_blocked := this.WhitelistedPIDs.HasKey(pid)
		if ((state && !pid_blocked) || (!state && pid_blocked)){
			if (this.GetHcState()){
				r := this.WinHttpRequest(this.HIDCERBERUS_URLS[state + 1] pid, InOutData := "", InOutHeaders := this.Headers(), "Timeout: 1`nNO_AUTO_REDIRECT")
				if (r == -1){
					if (state){
						this.WhitelistedPIDs[pid] := 1
					} else {
						this.WhitelistedPIDs.Delete(pid)
					}
					return true
				}
			}
		}
		return false
	}

	GetHcState(){
		lines := this.RunWaitOutput("cmd /c CHCP 437 & sc query Hidcerberus.Srv") ;DOOK
		RegExMatch(lines[5], "^\s+STATE\s+:\s(\d+)", out) ;DOOK
		return out1 == 4
	}
	
	SetHcState(state){
		serviceState := this.GetHcState()
		if (state){
			if (serviceState)
				return 1
			lines := this.RunWaitOutput("cmd /c sc start Hidcerberus.Srv")
                        sleep, 1000 ;DOOK
			return this.GetHcState()
		} else {
			if (!serviceState)
				return 1
			lines := this.RunWaitOutput("cmd /c sc stop Hidcerberus.Srv")
                        sleep, 1000 ;DOOK
			return !this.GetHcState()
		}
	}

	
	RunWaitOutput(cmd){
		dhw := A_DetectHiddenWindows
		DetectHiddenWindows On
		Run "%ComSpec%" /k,, Hide, pid
		while !(hConsole := WinExist("ahk_pid" pid))
			Sleep 10
		DllCall("AttachConsole", "UInt", pid)
		DetectHiddenWindows %dhw%
		objShell := ComObjCreate("WScript.Shell")
		;~ objExec := objShell.Exec("cmd /c " cmd)
		objExec := objShell.Exec(cmd)
		While !objExec.Status
			Sleep 100
		strLine := objExec.StdOut.ReadAll() ;read the output at once
		DllCall("FreeConsole")
		Process Exist, %pid%
		if (ErrorLevel == pid)
			Process Close, %pid%
		return StrSplit(Trim(StrReplace(strLine, "`r`n", "`n"), "`n"), "`n")
	}
	
	SetHgInstallState(state){
		isInstalled := this.IsHgInstalled()
		folder := A_Is64bitOS ? "x64" : "x86"
		if (state){
			if (isInstalled)
				return true
			lines := this.RunWaitOutput(A_ScriptDir "\Resources\devcon.exe install Resources\HidGuardian\" folder "\HidGuardian.inf Root\HidGuardian")
			lines := this.RunWaitOutput(A_ScriptDir "\Resources\devcon.exe classfilter HIDClass upper -HidGuardian")
			return this.IsHgInstalled()
		} else {
			if (!isInstalled)
				return true
			lines := this.RunWaitOutput(A_ScriptDir "\Resources\devcon.exe remove Root\HidGuardian")
			lines := this.RunWaitOutput(A_ScriptDir "\Resources\devcon.exe classfilter HIDClass upper !HidGuardian")
			return !this.IsHgInstalled()
		}
	}
	
	SetHcInstallState(state){
		isInstalled := this.IsHcInstalled()
		if (state){
			if (isInstalled)
				return true
			lines := this.RunWaitOutput(A_ScriptDir "\Resources\HidCerberus\HidCerberus.Srv.exe install")
			return this.IsHcInstalled()
		} else {
			if (!isInstalled)
				return true
			lines := this.RunWaitOutput(A_ScriptDir "\Resources\HidCerberus\HidCerberus.Srv.exe uninstall")
			return !this.IsHcInstalled()
		}
	}
	
	IsHgInstalled(){
		lines := this.RunWaitOutput(A_ScriptDir "\Resources\devcon.exe Status Root\HidGuardian")
		return RegExMatch(lines[lines.Length()], "\d+ matching device\(s\) found")
	}

	IsHcInstalled(){
		lines := this.RunWaitOutput("cmd /c CHCP 437 & sc query Hidcerberus.Srv") ;DOOK
		if (RegExMatch(lines[5], "^\s+STATE\s+:")){ ;DOOK
			return 1
		}
		return 0
	}
	
	; WinHttpRequest.ahk
	; 
	; Usage is similar to HTTPRequest (by VxE),
	; Please visit the HTTPRequest page (http://goo.gl/CcnNOY) for more details.
	; 
	; Supported Options:
	; 	NO_AUTO_REDIRECT
	; 	Timeout: <Seconds>
	; 	Proxy: <IP:Port>
	; 	Codepage: <CPnnn>	- e.g. "Codepage: 65001"
	; 	Charset: <Encoding>	- e.g. "Charset: UTF-8"
	; 	SaveAs: <FileName>
	; Return:
	; 	Success = -1, Timeout = 0, No response = Empty String
	; 
	; How to clear cookie:
	; 	WinHttpRequest( [] )
	; 
	; ChangeLog:
	; 	2015-4-25 - Added option "Method: HEAD"
	; 	2014-9-7  - Fixed a bug in "Charset:"
	; 	2014-7-11 - Fixed a bug in "Charset:"
	WinHttpRequest( URL, ByRef In_POST__Out_Data="", ByRef In_Out_HEADERS="", Options="" )
	{
		static nothing := ComObjError(0)
		static oHTTP   := ComObjCreate("WinHttp.WinHttpRequest.5.1")
		static oADO    := ComObjCreate("adodb.stream")

		; Clear cookie
		If IsObject(URL)
			Return oHTTP := ComObjCreate("WinHttp.WinHttpRequest.5.1")

		; POST or GET
		If (In_POST__Out_Data != "") || InStr(Options, "Method: POST")
			oHTTP.Open("POST", URL, True)
		Else If InStr(Options, "Method: HEAD")
			oHTTP.Open("HEAD", URL, True)
		Else
			oHTTP.Open("GET", URL, True)

		; HEADERS
		If In_Out_HEADERS
		{
			In_Out_HEADERS := Trim(In_Out_HEADERS, " `t`r`n")
			Loop, Parse, In_Out_HEADERS, `n, `r
			{
				If !( _pos := InStr(A_LoopField, ":") )
					Continue

				Header_Name  := SubStr(A_LoopField, 1, _pos-1)
				Header_Value := SubStr(A_LoopField, _pos+1)

				If (  Trim(Header_Value) != ""  )
					oHTTP.SetRequestHeader( Header_Name, Header_Value )
			}
		}

		If (In_POST__Out_Data != "") && !InStr(In_Out_HEADERS, "Content-Type:")
			oHTTP.SetRequestHeader("Content-Type", "application/x-www-form-urlencoded")

		; Options
		If Options
		{
			Loop, Parse, Options, `n, `r
			{
				If ( _pos := InStr(A_LoopField, "Timeout:") )
					Timeout := SubStr(A_LoopField, _pos+8)
				Else If ( _pos := InStr(A_LoopField, "Proxy:") )
					oHTTP.SetProxy( 2, SubStr(A_LoopField, _pos+6) )
				Else If ( _pos := InStr(A_LoopField, "Codepage:") )
					oHTTP.Option(2) := SubStr(A_LoopField, _pos+9)
			}

			oHTTP.Option(6) := InStr(Options, "NO_AUTO_REDIRECT") ? 0 : 1
		}

		; Send...
		oHTTP.Send(In_POST__Out_Data)
		ReturnCode := oHTTP.WaitForResponse(Timeout ? Timeout : -1)

		; Handle "SaveAs:" and "Charset:"
		If InStr(Options, "SaveAs:")
		{
			RegExMatch(Options, "i)SaveAs:[ \t]*\K[^\r\n]+", SavePath)

			oADO.Type := 1
			oADO.Open()
			oADO.Write( oHTTP.ResponseBody )
			oADO.SaveToFile( SavePath, 2 )
			oADO.Close()

			In_POST__Out_Data := ""
		}
		Else If InStr(Options, "Charset:")
		{
			RegExMatch(Options, "i)Charset:[ \t]*\K[\w-]+", Encoding)

			oADO.Type     := 1
			oADO.Mode     := 3
			oADO.Open()
			oADO.Write( oHTTP.ResponseBody() )
			oADO.Position := 0
			oADO.Type     := 2
			oADO.Charset  := Encoding
			In_POST__Out_Data := IsByRef(In_POST__Out_Data) ? oADO.ReadText() : ""
			oADO.Close()
		}
		Else
			In_POST__Out_Data := IsByRef(In_POST__Out_Data) ? oHTTP.ResponseText : ""
		
		; output headers
		In_Out_HEADERS := "HTTP/1.1 " oHTTP.Status() "`n" oHTTP.GetAllResponseHeaders()

		Return, ReturnCode ; Success = -1, Timeout = 0, No response = Empty String
	}

	Headers(referer = "")
	{
		Headers =
		( LTrim
			Referer: %referer%
			User-Agent: Opera/9.80 (Windows NT 5.1) Presto/2.12.388 Version/12.16
		)
		
		Return Headers
	}
}